<?php
chdir ('../../');
require_once('api/Simpla.php');

if (isset($_REQUEST["intid"]) && isset($_REQUEST["SIGN"]))
{
	// загрузка заказа
	
	$simpla = new Simpla();
	$order_id = $_REQUEST['MERCHANT_ORDER_ID'];
	$order = $simpla->orders->get_order(intval($order_id));
	
	if(!empty($order))
	{
		$method = $simpla->payment->get_payment_method(intval($order->payment_method_id));
		
		if(!empty($method))
		{
			$err = false;
			$message = '';
			$settings = unserialize($method->settings);
			
			// запись логов

            $log_text =
                "--------------------------------------------------------\n" .
                "id you	shoop   	" . $_REQUEST["MERCHANT_ID"] . "\n" .
                "amount				" . $_REQUEST["AMOUNT"] . "\n" .
                "kassa operation id " . $_REQUEST["intid"] . "\n" .
                "mercant order id	" . $_REQUEST["MERCHANT_ORDER_ID"] . "\n" .
                "e-mail client		" . $_REQUEST["P_EMAIL"] . "\n" .
                "phone client    	" . $_REQUEST["P_PHONE"] . "\n" .
                "currency			" . $_REQUEST["CUR_ID"] . "\n" .
                "sign				" . $_REQUEST["SIGN"] . "\n\n";
			
			$log_file = $settings['levipay_log'];
			
			if (!empty($log_file))
			{
				file_put_contents($_SERVER['DOCUMENT_ROOT'] . $log_file, $log_text, FILE_APPEND);
			}
			
			// проверка ip

			$sign_hash = md5( implode(":", array(
				$_REQUEST['MERCHANT_ID'],
				$_REQUEST['AMOUNT'],
                $settings['levipay_secret2'],
                $_REQUEST['MERCHANT_ORDER_ID'],
			)));
			
			$valid_ip = true;
			$sIP = str_replace(' ', '', $settings['levipay_ip_list']);

            if ( ! empty( $sIP ) ) {

                $ip_filter_arr = explode(',', $sIP);
                $this_ip  = (isset($_SERVER['HTTP_X_REAL_IP'])) ? $_SERVER['HTTP_X_REAL_IP'] : $_SERVER['REMOTE_ADDR'];

                foreach ( $ip_filter_arr as $key => $value ) {
                    $ip_filter_arr[ $key ] = ip2long( $value );
                }

                if ( ! in_array( ip2long($this_ip), $ip_filter_arr)) {
                    $valid_ip = false;
                }
            }
			
			if (!$valid_ip)
			{
				$message .= " - ip-адрес сервера не является доверенным\n" .
				"   доверенные ip: " . $sIP . "\n" .
				"   ip текущего сервера: " . $_SERVER['REMOTE_ADDR'] . "\n";
				$err = true;
			}

			if (!$err)
			{
				// проверка суммы
				
				if ($_REQUEST['AMOUNT'] != $order->total_price)
				{
					$message .= " - неправильная сумма\n";
					$err = true;
				}
				
				// проверка статуса
				
				if (!$err)
				{
					if ($_REQUEST['SIGN'] == $sign_hash) {

                        if (!$order->paid) {
                            $simpla->orders->update_order(intval($order_id),
                                array(
                                    'paid' => 1,
                                    'status' => $settings['levipay_order_status']
                                ));

                            $simpla->notify->email_order_user(intval($order_id));
                            $simpla->orders->close(intval($order_id));
                        }

                    }
                    else {

                        $message .= " - не совпадают цифровые подписи\n";
                        $err = true;
                    }
				}
			}
			
			if ($err)
			{
				$to = $settings['levipay_email'];

				if (!empty($to))
				{
					$message = "Не удалось провести платёж через систему LeviPay по следующим причинам:\n\n" . $message . "\n" . $log_text;
					$headers = "From: no-reply@" . $_SERVER['HTTP_HOST'] . "\r\n" . 
					"Content-type: text/plain; charset=utf-8 \r\n";
					mail($to, 'Ошибка оплаты', $message, $headers);
				}
				
				exit($order_id . ' | error | ' . $message);
			}
			else
			{
				exit('YES');
			}
		}
	}
}